DlAbstractXmiElement subclass: #DlAbstractUmlElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 18:44'!
addTaggedValue: aTaggedValue
	| elemName elem |
	elemName := 'Foundation.Core.ModelElement.taggedValue'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	^elem addChild: aTaggedValue! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:27'!
changeability
	| elem |
	elem := self findChildNamed: 'Foundation.Core.StructuralFeature.changeability'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:26'!
changeability: changeability 
	| elemName elem |
	elemName := 'Foundation.Core.StructuralFeature.changeability'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: changeability.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/20/2002 17:38'!
comment
	| elem |
	elem := self findChildNamed: 'Foundation.Core.ModelElement.comment'.
	^ elem isNil
		ifTrue: ['']
		ifFalse: [| comment | 
			comment := (elem findChildNamed: DlFcComment tagName ).
			comment elementName]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/20/2002 17:37'!
comment: aString 
	| elem |
	elem := self findChildNamed: 'Foundation.Core.ModelElement.comment'.
	elem isNil
		ifTrue: [| comElem | 
			comElem := self createChildNamed: 'Foundation.Core.ModelElement.comment'.
			comElem
				addChild: (DlFcComment content: aString)]
		ifFalse: [ (elem findChildNamed: DlFcComment tagName) elementName: aString]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 19:09'!
documentation
	^self tagAt: 'documentation'! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 19:00'!
documentation: aString
	self tagAt: 'documentation' put: aString! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 16:59'!
elementName
	| elem |
	elem := self findChildNamed: 'Foundation.Core.ModelElement.name'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem value]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 17:01'!
elementName: elemName 
	| elem |
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: 'Foundation.Core.ModelElement.name'].
	elem value: elemName.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 17:31'!
isAbstract
	| elem |
	elem := self findChildNamed: 'Foundation.Core.GeneralizableElement.isAbstract'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:23'!
isAbstract: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.GeneralizableElement.isAbstract'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 17:31'!
isLeaf
	| elem |
	elem := self findChildNamed: 'Foundation.Core.GeneralizableElement.isLeaf'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:24'!
isLeaf: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.GeneralizableElement.isLeaf'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 17:31'!
isRoot
	| elem |
	elem := self findChildNamed: 'Foundation.Core.GeneralizableElement.isRoot'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:24'!
isRoot: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.GeneralizableElement.isRoot'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:11'!
ownerScope
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Feature.ownerScope'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:25'!
ownerScope: scope 
	| elemName elem |
	elemName := 'Foundation.Core.Feature.ownerScope'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: scope.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 18:45'!
removeTaggedValue: aTaggedValue
	| elemName elem |
	elemName := 'Foundation.Core.ModelElement.taggedValue'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	^elem removeChild: aTaggedValue! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 19:07'!
tagAt: tagName
	| taggedValue |
	taggedValue := self taggedValues detect:[:each | each tagName = tagName] ifNone:[].
	^taggedValue isNil ifTrue: [] ifFalse: [taggedValue tagValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 18:47'!
tagAt: tagName put: tagValue
	| taggedValue |
	taggedValue := DlFeTaggedValue tag: tagName value: tagValue.
	self addTaggedValue: taggedValue! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/26/2002 19:03'!
taggedValues
	| elemName tagElem |
	elemName := 'Foundation.Core.ModelElement.taggedValue'.
	tagElem := self findChildNamed: elemName.
	^tagElem isNil ifTrue: [#()] ifFalse: [tagElem children]
	! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:28'!
targetScope
	| elem |
	elem := self findChildNamed: 'Foundation.Core.StructuralFeature.targetScope'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:27'!
targetScope: targetScope 
	| elemName elem |
	elemName := 'Foundation.Core.StructuralFeature.targetScope'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: targetScope.
! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:13'!
visibility
	| elem |
	elem := self findChildNamed: 'Foundation.Core.ModelElement.visibility'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlAbstractUmlElement methodsFor: 'actions' stamp: 'MU 3/7/2002 18:25'!
visibility: visibility 
	| elemName elem |
	elemName := 'Foundation.Core.ModelElement.visibility'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: visibility.
! !


!DlAbstractUmlElement methodsFor: 'testing' stamp: 'MU 4/5/2002 11:11'!
isAttribute
	^false! !

!DlAbstractUmlElement methodsFor: 'testing' stamp: 'MU 4/5/2002 11:11'!
isOperation
	^false! !

!DlAbstractUmlElement methodsFor: 'testing' stamp: 'MU 3/19/2002 18:12'!
isPackage
	^false! !


DlAbstractUmlElement subclass: #DlFcAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcAssociation methodsFor: 'private' stamp: 'MU 4/5/2002 12:23'!
connection
	| elemName elem |
	elemName := 'Foundation.Core.Association.connection'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [| connection | 
			connection := self createChildNamed: elemName.
			^ connection]
		ifFalse: [^ elem]! !


!DlFcAssociation methodsFor: 'actions' stamp: 'MU 4/5/2002 16:07'!
addAssociationEnd: aFcAssociationEnd
	aFcAssociationEnd association: self.
	^self connection addChild: aFcAssociationEnd! !

!DlFcAssociation methodsFor: 'actions' stamp: 'MU 4/5/2002 18:15'!
addFromAssociationEnd: aFcAssociationEnd
	| assocEnd |
	assocEnd := self addAssociationEnd: aFcAssociationEnd.
	assocEnd isNavigable: 'false'.
	^assocEnd! !

!DlFcAssociation methodsFor: 'actions' stamp: 'MU 4/5/2002 16:12'!
addToAssociationEnd: aFcAssociationEnd
	| assocEnd |
	assocEnd := self addAssociationEnd: aFcAssociationEnd.
	assocEnd isNavigable: 'true'.
	^assocEnd! !

!DlFcAssociation methodsFor: 'actions' stamp: 'MU 4/5/2002 18:05'!
from: fromFcClass role: fromClassRole to: toFcClass role: toClassRole
	| fromEnd toEnd |
	fromEnd := self addFromAssociationEnd: (DlFcAssociationEnd name: fromClassRole).
	fromEnd type: fromFcClass.
	toEnd := self addToAssociationEnd: (DlFcAssociationEnd name: toClassRole).
	toEnd type: toFcClass.

! !

!DlFcAssociation methodsFor: 'actions' stamp: 'MU 4/5/2002 16:48'!
from: fromFcClass to: toFcClass 
	^self from: fromFcClass role: '' to: toFcClass role: ''! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcAssociation class
	instanceVariableNames: ''!

!DlFcAssociation class methodsFor: 'instance creation' stamp: 'MU 4/5/2002 12:16'!
name: associationName 
	| inst |
	inst := self newWithId.
	inst elementName: associationName.
	^ inst! !


!DlFcAssociation class methodsFor: 'constants' stamp: 'MU 4/5/2002 12:13'!
defaultTagName
	^'Foundation.Core.Association'! !


DlAbstractUmlElement subclass: #DlFcAssociationEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcAssociationEnd methodsFor: 'actions' stamp: 'MU 4/5/2002 12:00'!
association: aFcAssociation
	| elemName elem |
	elemName := 'Foundation.Core.AssociationEnd.association'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem addChild: aFcAssociation asRef.! !

!DlFcAssociationEnd methodsFor: 'actions' stamp: 'MU 4/5/2002 12:09'!
isNavigable
	| elem |
	elem := self findChildNamed: 'Foundation.Core.ModelElement.isNavigable'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcAssociationEnd methodsFor: 'actions' stamp: 'MU 4/5/2002 12:09'!
isNavigable: isNavigable
	| elemName elem |
	elemName := 'Foundation.Core.AssociationEnd.isNavigable'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: isNavigable.
! !

!DlFcAssociationEnd methodsFor: 'actions' stamp: 'MU 4/5/2002 12:01'!
type: aFcClass
	| elemName elem |
	elemName := 'Foundation.Core.AssociationEnd.type'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem addChild: aFcClass asRef.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcAssociationEnd class
	instanceVariableNames: ''!

!DlFcAssociationEnd class methodsFor: 'constants' stamp: 'MU 4/5/2002 11:53'!
defaultTagName
	^'Foundation.Core.AssociationEnd'! !


!DlFcAssociationEnd class methodsFor: 'instance creation' stamp: 'MU 4/5/2002 12:04'!
name: roleName
	| inst |
	inst := self newWithId.
	inst elementName: roleName.
	^inst! !


DlAbstractUmlElement subclass: #DlFcAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcAttribute methodsFor: 'actions' stamp: 'MU 3/26/2002 18:50'!
beClassInstanceScope
	^self tagAt: 'classInstance' put: 'true'! !

!DlFcAttribute methodsFor: 'actions' stamp: 'MU 4/10/2002 12:02'!
initialValue
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Attribute.initialValue'.
	^ elem isNil
		ifTrue: ['']
		ifFalse: [| child | 
			child := (elem findChildNamed: DlFdExpression tagName ).
			child body]! !

!DlFcAttribute methodsFor: 'actions' stamp: 'MU 4/10/2002 11:59'!
initialValue: initialValue 
	| elemName elem |
	elemName := 'Foundation.Core.Attribute.initialValue'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [| childElem | 
			childElem := self createChildNamed: elemName.
			childElem
				addChild: (DlFdExpression body: initialValue)]
		ifFalse: [ (elem findChildNamed: DlFdExpression tagName) body: initialValue]! !

!DlFcAttribute methodsFor: 'actions' stamp: 'MU 4/9/2002 16:06'!
type: dataTypeOrClass 
	| elemName elem |
	elemName := 'Foundation.Core.StructuralFeature.type'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName].
	^ elem addChild: dataTypeOrClass asRef! !


!DlFcAttribute methodsFor: 'testing' stamp: 'MU 4/5/2002 11:10'!
isAttribute
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcAttribute class
	instanceVariableNames: ''!

!DlFcAttribute class methodsFor: 'constants' stamp: 'MU 3/7/2002 18:02'!
defaultTagName
	^'Foundation.Core.Attribute'! !


!DlFcAttribute class methodsFor: 'instance creation' stamp: 'MU 3/15/2002 17:16'!
name: attribName ownerScope: ownerScope
	| inst |
	inst := self name: attribName ownerScope: ownerScope visibility: 'private'.
	^inst ! !

!DlFcAttribute class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 14:20'!
name: attribName ownerScope: ownerScope visibility: visibility 
	| inst |
	inst := self newWithId.
	inst elementName: attribName.
	inst visibility: visibility.
	inst ownerScope: ownerScope.
	^inst! !


!DlFcAttribute class methodsFor: 'instance creation-st' stamp: 'MU 3/15/2002 17:24'!
name: attribName
	^self name: attribName isClassVariable: false! !

!DlFcAttribute class methodsFor: 'instance creation-st' stamp: 'MU 3/15/2002 17:24'!
name: attribName isClassVariable: aBoolean
	| scope inst |
	scope := aBoolean ifTrue: [ 'classifier' ] ifFalse: ['instance'].
	inst := self name: attribName ownerScope: scope.
	^inst ! !


DlAbstractUmlElement subclass: #DlFcClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcClass methodsFor: 'elements' stamp: 'MU 3/15/2002 17:28'!
addClassfierFeature
	^self addChild: (DlFcClassifierFeature new)! !

!DlFcClass methodsFor: 'elements' stamp: 'MU 3/15/2002 17:47'!
classfierFeature
	^self findChildNamed: DlFcClassifierFeature tagName! !

!DlFcClass methodsFor: 'elements' stamp: 'MU 3/19/2002 18:34'!
hasClassfierFeature
	^(self findChildNamed: DlFcClassifierFeature tagName) notNil! !


!DlFcClass methodsFor: 'actions' stamp: 'MU 3/26/2002 18:56'!
addClassInstVarNamed: classVarName 
	| att |
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	att := (DlFcAttribute name: classVarName isClassVariable: true).
	att beClassInstanceScope.
	^self classfierFeature addChild: att! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/19/2002 14:17'!
addClassMethodNamed: classMethodName 
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	^self classfierFeature addChild:(DlFcOperation name: classMethodName isClassMethod: true)! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/19/2002 14:17'!
addClassVarNamed: classVarName 
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	^self classfierFeature addChild:(DlFcAttribute name: classVarName isClassVariable: true)! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/19/2002 14:17'!
addInstMethodNamed: instMethodName 
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	^self classfierFeature addChild:(DlFcOperation name: instMethodName )! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/15/2002 17:49'!
addInstVarNamed: instVarName 
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	^self classfierFeature addChild:(DlFcAttribute name: instVarName)! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 4/12/2002 13:42'!
addMethod: fcOperation
	self hasClassfierFeature ifFalse: [self addClassfierFeature].
	^self classfierFeature addChild: fcOperation! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 4/5/2002 11:16'!
attributes
	self hasClassfierFeature ifFalse: [^#()].
	^self classfierFeature children select: [:each | each isAttribute]! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/20/2002 16:40'!
generalizationEnd: anXmiUmlGeneralization  
	| elemName elem |
	elemName := 'Foundation.Core.GeneralizableElement.generalization'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem addChild: anXmiUmlGeneralization asRef.
! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 4/5/2002 11:14'!
operations
	self hasClassfierFeature ifFalse: [^#()].
	^self classfierFeature children select: [:each | each isOperation]! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 4/8/2002 15:18'!
package
	^self parent notNil ifTrue: [self parent parent] ifFalse:[nil]! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/20/2002 16:40'!
specializationEnd: anXmiUmlGeneralization  
	| elemName elem |
	elemName := 'Foundation.Core.GeneralizableElement.specialization'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem addChild: anXmiUmlGeneralization asRef.
! !

!DlFcClass methodsFor: 'actions' stamp: 'MU 3/20/2002 16:39'!
superclass
	| elem |
	elem := self findChildNamed: 'Foundation.Core.GeneralizableElement.specialization'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem parent]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcClass class
	instanceVariableNames: ''!

!DlFcClass class methodsFor: 'constants' stamp: 'MU 3/7/2002 17:56'!
defaultTagName
	^'Foundation.Core.Class'! !


!DlFcClass class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 14:00'!
name: elemName 
	| inst |
	inst := self newWithId.
	inst elementName: elemName.
	^inst! !


DlAbstractUmlElement subclass: #DlFcClassifierFeature
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcClassifierFeature class
	instanceVariableNames: ''!

!DlFcClassifierFeature class methodsFor: 'constants' stamp: 'MU 3/7/2002 18:01'!
defaultTagName
	^'Foundation.Core.Classifier.feature'! !


DlAbstractUmlElement subclass: #DlFcComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcComment class
	instanceVariableNames: ''!

!DlFcComment class methodsFor: 'instance creation' stamp: 'MU 3/20/2002 17:39'!
content: aString
	^self newWithId elementName: aString 
	! !


!DlFcComment class methodsFor: 'constants' stamp: 'MU 3/7/2002 19:12'!
defaultTagName
	^'Foundation.Core.Comment'! !


DlAbstractUmlElement subclass: #DlFcDataType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcDataType class
	instanceVariableNames: ''!

!DlFcDataType class methodsFor: 'constants' stamp: 'MU 3/7/2002 19:06'!
defaultTagName
	^'Foundation.Core.DataType'! !


!DlFcDataType class methodsFor: 'instance creation' stamp: 'MU 4/10/2002 13:48'!
name: dataTypeName
	| inst |
	inst := self newWithId.
	inst elementName: dataTypeName.
	^inst! !


DlAbstractUmlElement subclass: #DlFcFeatureOwner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcFeatureOwner class
	instanceVariableNames: ''!

!DlFcFeatureOwner class methodsFor: 'constants' stamp: 'MU 3/7/2002 19:07'!
defaultTagName
	^'Foundation.Core.Feature.owner'! !


DlAbstractUmlElement subclass: #DlFcGeneralization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcGeneralization methodsFor: 'actions' stamp: 'MU 3/20/2002 16:39'!
childElement
	| elemName elem |
	elemName := 'Foundation.Core.Generalization.child'.
	elem := self findChildNamed: elemName.
	^elem isNil
		ifTrue: [nil ] ifFalse: [elem]
	! !

!DlFcGeneralization methodsFor: 'actions' stamp: 'MU 3/20/2002 16:42'!
childElement: anUmlElement
	| elemName elem |
	anUmlElement generalizationEnd: self.
	elemName := 'Foundation.Core.Generalization.child'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	^elem addChild: anUmlElement asRef! !

!DlFcGeneralization methodsFor: 'actions' stamp: 'MU 3/20/2002 16:39'!
parentElement
	| elemName elem |
	elemName := 'Foundation.Core.Generalization.parent'.
	elem := self findChildNamed: elemName.
	^elem isNil
		ifTrue: [nil ] ifFalse: [elem]
	! !

!DlFcGeneralization methodsFor: 'actions' stamp: 'MU 3/20/2002 16:42'!
parentElement: anUmlElement
	| elemName elem |
	anUmlElement specializationEnd: self.
	elemName := 'Foundation.Core.Generalization.parent'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	^elem addChild: anUmlElement asRef! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcGeneralization class
	instanceVariableNames: ''!

!DlFcGeneralization class methodsFor: 'constants' stamp: 'MU 3/7/2002 17:57'!
defaultTagName
	^'Foundation.Core.Generalization'! !


!DlFcGeneralization class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 18:52'!
parent: parentDlFcClass child: childDlFcClass
	| inst |
	inst := self newWithId.
	inst parentElement: parentDlFcClass.
	inst childElement: childDlFcClass.
	^inst! !


DlAbstractUmlElement subclass: #DlFcModelElementComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcModelElementComment class
	instanceVariableNames: ''!

!DlFcModelElementComment class methodsFor: 'constants' stamp: 'MU 3/7/2002 19:12'!
defaultTagName
	^'Foundation.Core.ModelElement.comment'! !


DlAbstractUmlElement subclass: #DlFcNamespaceOwnedElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcNamespaceOwnedElement class
	instanceVariableNames: ''!

!DlFcNamespaceOwnedElement class methodsFor: 'constants' stamp: 'MU 3/7/2002 17:40'!
defaultTagName
	^'Foundation.Core.Namespace.ownedElement'! !


DlAbstractUmlElement subclass: #DlFcOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFcOperation methodsFor: 'actions' stamp: 'MU 4/5/2002 11:25'!
addParameter: aFcParameter
	| elemName elem |
	elemName := 'Foundation.Core.BehavioralFeature.parameter'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	^elem addChild: aFcParameter! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:33'!
concurrency
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Operation.concurrency'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:35'!
concurrency: concurrency 
	| elemName elem |
	elemName := 'Foundation.Core.Operation.concurrency'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: concurrency.! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:41'!
isAbstract
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Operation.isAbstract'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:41'!
isAbstract: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.Operation.isAbstract'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:42'!
isLeaf
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Operation.isLeaf'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:42'!
isLeaf: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.Operation.isLeaf'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:40'!
isQuery
	| elem |
	elem := self findChildNamed: 'Foundation.Core.BehavioralFeature.isQuery'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:40'!
isQuery: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.BehavioralFeature.isQuery'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:43'!
isRoot
	| elem |
	elem := self findChildNamed: 'Foundation.Core.Operation.isRoot'.
	^ elem isNil
		ifFalse: [elem xmiValue]! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 3/7/2002 18:43'!
isRoot: boolean 
	| elemName elem |
	elemName := 'Foundation.Core.Operation.isRoot'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName ].
	elem xmiValue: boolean.
! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 4/5/2002 10:40'!
protocol
	^self tagAt: 'protocol'! !

!DlFcOperation methodsFor: 'actions' stamp: 'MU 4/5/2002 10:40'!
protocol: aString
	self tagAt: 'protocol' put: aString! !


!DlFcOperation methodsFor: 'testing' stamp: 'MU 4/5/2002 11:10'!
isOperation
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcOperation class
	instanceVariableNames: ''!

!DlFcOperation class methodsFor: 'constants' stamp: 'MU 3/7/2002 18:03'!
defaultTagName
	^'Foundation.Core.Operation'! !


!DlFcOperation class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 14:10'!
name: attribName ownerScope: ownerScope
	| inst |
	inst := self name: attribName ownerScope: ownerScope visibility: 'public'.
	^inst ! !

!DlFcOperation class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 14:20'!
name: attribName ownerScope: ownerScope visibility: visibility 
	| inst |
	inst := self newWithId.
	inst elementName: attribName.
	inst visibility: visibility.
	inst ownerScope: ownerScope.
	^inst! !


!DlFcOperation class methodsFor: 'instance creation-st' stamp: 'MU 3/19/2002 14:12'!
name: attribName
	^self name: attribName isClassMethod: false! !

!DlFcOperation class methodsFor: 'instance creation-st' stamp: 'MU 3/19/2002 14:11'!
name: attribName isClassMethod: aBoolean
	| scope inst |
	scope := aBoolean ifTrue: [ 'classifier' ] ifFalse: ['instance'].
	inst := self name: attribName ownerScope: scope.
	^inst ! !


DlAbstractUmlElement subclass: #DlFcParameter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcParameter class
	instanceVariableNames: ''!

!DlFcParameter class methodsFor: 'constants' stamp: 'MU 4/5/2002 11:02'!
defaultTagName
	^'Foundation.Core.Parameter'! !


!DlFcParameter class methodsFor: 'instance creation' stamp: 'MU 4/5/2002 11:05'!
name: paramName
	| inst |
	inst := self newWithId.
	inst elementName: paramName.
	^inst! !


DlAbstractXmiElement subclass: #DlFcStructuralFeatureMultiplicity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFcStructuralFeatureMultiplicity class
	instanceVariableNames: ''!

!DlFcStructuralFeatureMultiplicity class methodsFor: 'constants' stamp: 'MU 3/7/2002 18:16'!
defaultTagName
	^'Foundation.Core.StructuralFeature.multiplicity'! !


DlAbstractUmlElement subclass: #DlFdExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFdExpression methodsFor: 'actions' stamp: 'MU 4/10/2002 11:51'!
body
	| elem |
	elem := self findChildNamed: 'Foundation.Data_Types.Expression.body'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem value]! !

!DlFdExpression methodsFor: 'actions' stamp: 'MU 4/10/2002 11:51'!
body: expressionBody
	|  elemName elem |
	elemName := 'Foundation.Data_Types.Expression.body'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName].
	elem value: expressionBody.! !

!DlFdExpression methodsFor: 'actions' stamp: 'MU 4/10/2002 11:48'!
language
	| elem |
	elem := self findChildNamed: 'Foundation.Data_Types.Expression.language'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem value]! !

!DlFdExpression methodsFor: 'actions' stamp: 'MU 4/10/2002 11:49'!
language: languageName
	|  elemName elem |
	elemName := 'Foundation.Data_Types.Expression.language'.
	elem := self findChildNamed: elemName.
	elem isNil
		ifTrue: [elem := self createChildNamed: elemName].
	elem value: languageName.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFdExpression class
	instanceVariableNames: ''!

!DlFdExpression class methodsFor: 'constants' stamp: 'MU 4/10/2002 11:37'!
defaultTagName
	^'Foundation.Data_Types.Expression'! !


!DlFdExpression class methodsFor: 'instance creation' stamp: 'MU 4/10/2002 11:53'!
body: bodyExpression 
	^ self language: 'Smalltalk' body: bodyExpression! !

!DlFdExpression class methodsFor: 'instance creation' stamp: 'MU 4/10/2002 11:52'!
language: languageName body: bodyExpression 
	^ self newWithId language: languageName;
		 body: bodyExpression! !


DlAbstractUmlElement subclass: #DlFdMultiplicity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFdMultiplicity methodsFor: 'actions' stamp: 'MU 3/7/2002 18:19'!
lower: lower upper: upper! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFdMultiplicity class
	instanceVariableNames: ''!

!DlFdMultiplicity class methodsFor: 'instance creation' stamp: 'MU 3/7/2002 18:19'!
lower: lower upper: upper! !


!DlFdMultiplicity class methodsFor: 'constants' stamp: 'MU 3/7/2002 18:18'!
defaultTagName
	^'Foundation.Data_Types.Multiplicity'! !


DlAbstractUmlElement subclass: #DlFeStereotype
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFeStereotype class
	instanceVariableNames: ''!

!DlFeStereotype class methodsFor: 'constants' stamp: 'MU 3/7/2002 19:02'!
defaultTagName
	^'Foundation.Extension_Mechanisms.Stereotype'! !


DlAbstractUmlElement subclass: #DlFeTaggedValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlFeTaggedValue methodsFor: 'initialize-release' stamp: 'MU 3/26/2002 18:40'!
tag: tagString value: valueString
	self privTag: tagString.
	self privValue: valueString! !


!DlFeTaggedValue methodsFor: 'actions' stamp: 'MU 3/26/2002 19:05'!
tagName
	^self privTag! !

!DlFeTaggedValue methodsFor: 'actions' stamp: 'MU 3/26/2002 19:07'!
tagValue
	^self privValue! !


!DlFeTaggedValue methodsFor: 'private' stamp: 'MU 3/26/2002 18:39'!
privTag
	| elem |
	elem := self findChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.tag'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem value]! !

!DlFeTaggedValue methodsFor: 'private' stamp: 'MU 3/26/2002 18:39'!
privTag: aString 
	| elem |
	elem := self findChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.tag'.
	elem isNil
		ifTrue: [elem := self createChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.tag'].
	elem value: aString.! !

!DlFeTaggedValue methodsFor: 'private' stamp: 'MU 3/26/2002 18:38'!
privValue
	| elem |
	elem := self findChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.value'.
	^elem isNil  ifTrue: [nil]
		ifFalse: [elem value]! !

!DlFeTaggedValue methodsFor: 'private' stamp: 'MU 3/26/2002 18:38'!
privValue: aString 
	| elem |
	elem := self findChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.value'.
	elem isNil
		ifTrue: [elem := self createChildNamed: 'Foundation.Extension_Mechanisms.TaggedValue.value'].
	elem value: aString.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlFeTaggedValue class
	instanceVariableNames: ''!

!DlFeTaggedValue class methodsFor: 'constants' stamp: 'MU 3/26/2002 18:12'!
defaultTagName
	^'Foundation.Extension_Mechanisms.TaggedValue'! !


!DlFeTaggedValue class methodsFor: 'instance creation' stamp: 'MU 3/26/2002 18:40'!
tag: tagString value: valueString
	| inst |
	inst := self newWithId.
	inst tag: tagString value: valueString.
	^inst! !


DlAbstractUmlElement subclass: #DlMmPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlMmPackage methodsFor: 'elements' stamp: 'MU 3/19/2002 14:42'!
addOwnedElement
	| ownedElement |
	ownedElement := self addChild: (DlFcNamespaceOwnedElement new).
	^ownedElement! !

!DlMmPackage methodsFor: 'elements' stamp: 'MU 3/19/2002 14:42'!
ownedElement
	
	^self findChildNamed: DlFcNamespaceOwnedElement tagName
	! !


!DlMmPackage methodsFor: 'actions' stamp: 'MU 4/5/2002 17:43'!
add: modelElement
	^self addModelElement: modelElement! !

!DlMmPackage methodsFor: 'actions' stamp: 'MU 4/5/2002 17:43'!
addAll: aCollectionOfModelElement
	aCollectionOfModelElement do: [:each | self add: each ].
	^aCollectionOfModelElement
	! !

!DlMmPackage methodsFor: 'actions' stamp: 'MU 4/8/2002 17:28'!
addModelElement: modelElement
	modelElement isNil ifTrue: [^self].
	^self ownedElement addChild: modelElement! !

!DlMmPackage methodsFor: 'actions' stamp: 'MU 3/19/2002 18:12'!
classes
	^self ownedElement children select: [:each | each isPackage not].! !


!DlMmPackage methodsFor: 'testing' stamp: 'MU 3/19/2002 18:11'!
isPackage
	^true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlMmPackage class
	instanceVariableNames: ''!

!DlMmPackage class methodsFor: 'constants' stamp: 'MU 3/7/2002 17:38'!
defaultTagName
	^'Model_Management.Package'! !


!DlMmPackage class methodsFor: 'instance creation' stamp: 'MU 3/19/2002 14:45'!
name: elemName 
	| inst |
	inst := self newWithId.
	inst elementName: elemName.
	inst addOwnedElement.
	^inst! !


DlMmPackage subclass: #DlMmModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlMmModel methodsFor: 'actions' stamp: 'MU 3/19/2002 17:44'!
root
	^self parent parent! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlMmModel class
	instanceVariableNames: ''!

!DlMmModel class methodsFor: 'constants' stamp: 'MU 3/19/2002 14:48'!
defaultTagName
	^'Model_Management.Model'! !


DlXmiRootElement subclass: #DlUmlRootElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Dandelion-xmi-uml-element'!

!DlUmlRootElement methodsFor: 'actions' stamp: 'MU 3/18/2002 19:09'!
addModel: model
	^self content addChild: model! !

!DlUmlRootElement methodsFor: 'actions' stamp: 'MU 3/18/2002 19:21'!
addModelNamed: aModelName 
	| model |
	model := self content addChild: (DlMmModel name: aModelName).
	^ model! !


!DlUmlRootElement methodsFor: 'elements' stamp: 'MU 3/18/2002 19:08'!
addModel
	| model |
	model := self content addChild: (DlMmModel new).
	^model! !

!DlUmlRootElement methodsFor: 'elements' stamp: 'MU 3/18/2002 19:10'!
model
	^self content findChildNamed: (DlMmModel tagName).
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DlUmlRootElement class
	instanceVariableNames: ''!

!DlUmlRootElement class methodsFor: 'instance creation' stamp: 'MU 3/18/2002 19:13'!
new
	| root header |
	root := super new.
	header := root addHeader.
	header exporter: 'Dandelion' exporterVersion: '0.5'.
	header metamodel: 'UML' version: '1.3'.
	root addContent.
	^ root! !
